> For the complete documentation index, see [llms.txt](https://docs.coherence.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.coherence.io/0.4.14/api-reference/ecs.md).

# Entity Component System

### Overview

ECS is a way of writing code that provides high performance by default.

Under the hood **coherence** is entirely ECS based but we supply the **coherence** Toolkit which is Mono-based to make it easier to make massive multiplayer games whatever way you want.

{% hint style="info" %}
The current version of **coherence** uses the Unity Entities package. Unity [recently announced ](https://forum.unity.com/threads/notice-on-dots-compatibility-with-unity-2021-1.1091800/#post-7029421)that they will not support this package in Unity 2021 for a while. This means that the current recommended Unity version for using **coherence** is Unity 2020 LTS. This is only temporary as we have been working on removing the reliance on Entities internally.
{% endhint %}

If you would like to use the **coherence** SDK without the toolkit, we would recommend you take some time to learn about ECS and DOTS (Data Orientated Tech Stack) with Unity.

### ECS has three principal parts:

Entities — the entities, or things, that populate your game or program.

Components — the data associated with your entities, but organized by the data itself rather than by entity. (This difference in organization is one of the key differences between an object-oriented and a data-oriented design.)

Systems — the logic that transforms the component data from its current state to its next state— for example, a system might update the positions of all moving entities by their velocity times the time interval since the previous frame.

Here are various materials to learn:

* Unity DOTS Overview - <https://unity.com/dots>
* Unity ECS Documentation - <https://docs.unity3d.com/Packages/com.unity.entities@0.14/manual/index.html>
* Unity Learn, ECS -  <https://learn.unity.com/tutorial/entity-component-system>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.coherence.io/0.4.14/api-reference/ecs.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
